(function() {
    tinymce.PluginManager.add('scoilnetResources_tc_button', function(editor, url) {

        var API_URL = 'https://www.scoilnet.ie/api/facets/';

        function getValues(arrayName, url_end) {
            var arrayValues = [];

            if (!sessionStorage.getItem(arrayName)) {
                doAjaxCall(arrayName, arrayValues, url_end);
            } else {
                var tempArray = JSON.parse(sessionStorage.getItem(arrayName));
                arrayValues.push({
                    value: '',
                    text: 'Select'
                });
                for (i in tempArray) {
                    if (tempArray[i].text !== null) {
                        arrayValues.push({
                            value: tempArray[i].id,
                            text: tempArray[i].text
                        });
                    }
                    else {
                        arrayValues.push({
                            value: tempArray[i].id,
                            text: 'None'
                        });
                    }
                }
            }

            return arrayValues;
        }


        //get the data from the API and return data array
        function doAjaxCall(arrayName, arrayValues, url_end) {

            $.ajax({
                url: API_URL + url_end + "?callback=scoilnet",
                dataType: 'jsonp',
                success: function(results) {
                    arrayValues.push({
                        value: '',
                        text: 'Select'
                    });
                    for (i in results.data) {
                        if (results.data[i].title !== null) {
                            arrayValues.push({
                                text: results.data[i].title,
                                value: results.data[i].id
                            });
                        }
                        else {
                            arrayValues.push({
                                text: 'None',
                                value: results.data[i].id
                            });
                        }
                    }
                    //save the results into the session storage object
                    sessionStorage.setItem(arrayName, JSON.stringify(storageArray));
                }
            });
        }
        ;


        editor.addButton('scoilnetResources_tc_button', {
            title: 'Scoilnet Resources',
            icon: 'icon scoilnet-own-icon',
            type: 'menubutton',
            menu: [
                {
                    text: 'Scoilnet Search Results',
                    onclick: function() {
                        editor.windowManager.open({
                            title: 'Insert Scoilnet Search Results',
                            body: [
                                {
                                    type: 'container',
                                    html: '<p>All fields below are optional. They will overwrite the settings from the plugin options page.</p>'
                                },
                                {
                                    type: 'textbox',
                                    name: 'query',
                                    label: 'Your Query'
                                },
                                {
                                    type: 'textbox',
                                    name: 'limit',
                                    label: 'Number of resources to return per page. Default is 20. Max is 50.'
                                },
                                {
                                    //type: 'listbox',
                                    type: 'textbox',
                                    name: 'school_level',
                                    label: 'School Level (comma seperated ids)'
                                            //'values': getValues('school_level_array','level')                              
                                },
                                {
                                    //type: 'listbox',
                                    type: 'textbox',
                                    name: 'school_grade',
                                    label: 'School Grade (comma seperated ids)'
                                            //'values': getValues('school_grade_array','grade')                              
                                },
                                {
                                    //type: 'listbox',
                                    type: 'textbox',
                                    name: 'school_discipline',
                                    label: 'School Subject (comma seperated ids)'
                                            //'values': getValues('school_discipline_array','discipline')
                                },
                                {
                                    //type: 'listbox',
                                    type: 'textbox',
                                    name: 'school_topic',
                                    label: 'School Strand (comma seperated ids)'
                                            //'values': getValues('school_topic_array','strand')
                                },
                                {
                                    //type: 'listbox',
                                    type: 'textbox',
                                    name: 'school_subtopic',
                                    label: 'School Strand Unit (comma seperated ids)'
                                            //'values': getValues('school_subtopic_array','strandunit')
                                },
                                {
                                    //type: 'listbox',
                                    type: 'textbox',
                                    name: 'resource_language',
                                    label: 'Resource Language (comma seperated ids)'
                                            //'values': getValues('resource_language_array','resourcelanguage')
                                },
                                {
                                    //type: 'listbox',
                                    type: 'textbox',
                                    name: 'resource_type',
                                    label: 'Resource Type (comma seperated ids)',
                                    //'values': getValues('resource_type_array','resourcetype')
                                },
                                /*
                                {
                                    type: 'listbox',
                                    name: 'sort',
                                    label: 'Sort by',
                                    'values': [
                                        {text: 'Select sort by', value: ''},
                                        {text: 'Best march', value: 'score'},
                                        {text: 'Most recent', value: 'creation_date'}
                                    ]
                                },
                                */
                                {
                                    type: 'listbox',
                                    name: 'lang',
                                    label: 'Language of text results and facets.',
                                    'values': [
                                        {text: 'Select language', value: ''},
                                        {text: 'English', value: 'en'},
                                        {text: 'Gaeilge', value: 'ga'},
                                        {text: 'French', value: 'fr'},
                                        {text: 'German', value: 'de'}
                                    ]
                                }
                            ],
                            onsubmit: function(e) {
                                var parameters = '';
                                if (e.data.query)
                                    parameters += ' q="' + e.data.query + '"';
                                if (e.data.school_level)
                                    parameters += ' school_level="' + e.data.school_level + '"';
                                if (e.data.school_grade)
                                    parameters += ' school_grade="' + e.data.school_grade + '"';
                                if (e.data.school_discipline)
                                    parameters += ' school_discipline="' + e.data.school_discipline + '"';
                                if (e.data.school_topic)
                                    parameters += ' school_topic="' + e.data.school_topic + '"';
                                if (e.data.school_subtopic)
                                    parameters += ' school_subtopic="' + e.data.school_subtopic + '"';
                                if (e.data.resource_language)
                                    parameters += ' resource_language="' + e.data.resource_language + '"';
                                if (e.data.resource_type)
                                    parameters += ' resource_type="' + e.data.resource_type + '"';
                                if (e.data.sort)
                                    parameters += ' sort="' + e.data.sort + '"';
                                if (e.data.lang)
                                    parameters += ' lang="' + e.data.lang + '"';
                                if (e.data.limit)
                                    parameters += ' limit="' + e.data.limit + '"';

                                editor.insertContent('[getScoilnetResults' + parameters + ']');
                            }
                        });
                        facets_init();
                    }
                },
                {
                    text: 'Scoilnet Search Box',
                    onclick: function() {
                        editor.insertContent('[widget widget_name="scoilnetResources_SearchBoxWidget"]');
                    }
                }
            ]
        });
    });
})();