var API_URL = 'https://www.scoilnet.ie/api/facets/';

function format_curr_selection(item) {
    return item.text;
}

jQuery(document).ready(function($) {

    facets_init = function() {
        if (!sessionStorage.getItem("school_level_array")) {
            doAjaxCall('school_level_array', 'level', '.school_level', 'Select a School Level');
        } else {
            var data_array = JSON.parse(sessionStorage.getItem("school_level_array"));
            populateElement(data_array, '.school_level', 'Select a School Level');
        }

        if (!sessionStorage.getItem("school_grade_array")) {
            doAjaxCall('school_grade_array', 'grade', '.school_grade', 'Select a School Grade');
        } else {
            var data_array = JSON.parse(sessionStorage.getItem("school_grade_array"));
            populateElement(data_array, '.school_grade', 'Select a School Grade');
        }

        if (!sessionStorage.getItem("school_discipline_array")) {
            doAjaxCall('school_discipline_array', 'discipline', '.school_discipline', 'Select or search for a School Subject');
        } else {
            var data_array = JSON.parse(sessionStorage.getItem("school_discipline_array"));
            populateElement(data_array, '.school_discipline', 'Select or search for a School Subject');
        }

        if (!sessionStorage.getItem("school_topic_array")) {
            doAjaxCall('school_topic_array', 'strand', '.school_topic', 'Select or search for a Strand');
        } else {
            var data_array = JSON.parse(sessionStorage.getItem("school_topic_array"));
            populateElement(data_array, '.school_topic', 'Select or search for a Strand');
        }

        if (!sessionStorage.getItem("school_subtopic_array")) {
            doAjaxCall('school_subtopic_array', 'strandunit', '.school_subtopic', 'Select or search for a Strand Unit');
        } else {
            var data_array = JSON.parse(sessionStorage.getItem("school_subtopic_array"));
            populateElement(data_array, '.school_subtopic', 'Select or search for a Strand Unit');
        }

        if (!sessionStorage.getItem("resource_language_array")) {
            doAjaxCall('resource_language_array', 'resourcelanguage', '.resource_language', 'Select or search for a Resource Language');
        } else {
            var data_array = JSON.parse(sessionStorage.getItem("resource_language_array"));
            populateElement(data_array, '.resource_language', 'Select or search for a Resource Language');
        }

        if (!sessionStorage.getItem("resource_type_array")) {
            doAjaxCall('resource_type_array', 'resourcetype', '.resource_resourcetype', 'Select or search for a Resource Type');
        } else {
            var data_array = JSON.parse(sessionStorage.getItem("resource_type_array"));
            populateElement(data_array, '.resource_resourcetype', 'Select or search for a Resource Type');
        }

    }


    //get the data from the API and return data array
    doAjaxCall = function(arrayName, url_end, element, placeholderText) {
        var storageArray = [];

        $.ajax({
            url: API_URL + url_end + "?callback=scoilnet",
            dataType: 'jsonp',
            success: function(results) {
                for (i in results.data) {
                    if (results.data[i].title !== null) {
                        storageArray.push({
                            id: results.data[i].id,
                            text: results.data[i].title
                        });
                    }
                    else {
                        storageArray.push({
                            id: results.data[i].id,
                            text: 'None'
                        });
                    }
                }
                //save the results into the session storage object
                sessionStorage.setItem(arrayName, JSON.stringify(storageArray));

                populateElement(storageArray, element, placeholderText);
            }
        });
    };

    //don't do another ajax call if the data was already fetched from the API
    populateElement = function(storageArray, element, placeholderText) {

        if ($('#widgets-right').length) {
            $('#widgets-right').find('input' + element + ':not(.select2-offscreen)').each(function() {
                $(this).select2({
                    data: storageArray,
                    placeholder: placeholderText,
                    multiple: true,
                    formatSelection: format_curr_selection,
                    formatResult: format_curr_selection
                });
            })
        }
        else {

            $('input' + element + ':not(.select2-offscreen)').each(function() {
                $(this).select2({
                    data: storageArray,
                    placeholder: placeholderText,
                    multiple: true,
                    formatSelection: format_curr_selection,
                    formatResult: format_curr_selection
                });
            })
        }

    };

    facets_init();

    // ---------------------------------------------
    // On widget save
    // ---------------------------------------------
    jQuery(document).ajaxSuccess(function(e, xhr, settings) {

        var widget_id_base = 'scoilnetresources_searchboxwidget';

        if (settings.data !== "undefined") {

            if (settings.data.search('action=save-widget') != -1 && settings.data.search('id_base=' + widget_id_base) != -1) {
                facets_init();
            }
        }
    });





});
