<?php
/**
 * Description of scoilnetResources_SearchBoxWidget
 *
 * @author Admin
 */
add_action("admin_enqueue_scripts", 'js_includes');

function js_includes() {
    wp_enqueue_script('select2', scoilnetResources_URL . 'js/select2/select2.min.js', array('jquery'), false, false);
    wp_enqueue_style('select2', scoilnetResources_URL . 'js/select2/select2.css', false);
    wp_enqueue_script('scoilnetResources', scoilnetResources_URL . 'js/scoilnet-resouces-admin.js', array('jquery', 'select2'), false, true);
}

class scoilnetResources_SearchBoxWidget extends WP_Widget {

    /**
     * Register widget with WordPress.
     */
    function __construct() {
        parent::__construct(
                'scoilnetResources_SearchBoxWidget', // Base ID
                __('Scoilnet Resources Searchbox', 'scoilnetResources'), // Name
                array('description' => __('Scoilnet Resources Searchbox Widget', 'scoilnetResources'),) // Args
        );
        if (is_active_widget(false, false, $this->id_base)) {
            //add_action( 'wp_head', array( $this, 'js' ) );
        }
    }

    function js($instanceId) {
        ?>
        <script type="text/javascript">
            jQuery(document).ready(function($) {

                jQuery('#<?php echo $instanceId ?>').on("keypress", function(event) {
                    if (event.keyCode == 13) {
                        jQuery('#ScoilSearch_submit-<?php echo $instanceId ?>').click();
                    }
                });

                jQuery("#ScoilSearch_submit-<?php echo $instanceId ?>").on("click", function() {
                    if (jQuery('#<?php echo $instanceId ?>').val())
                    {
        <?php
        $scoilnetResources_options = get_option('scoilnetResources_options');
        $searchResultsPageUrl = $scoilnetResources_options['_searchResultsPageUrl'];
        if (!empty($searchResultsPageUrl)) {
            ?>
                            document.location.href = "<?php echo get_permalink($searchResultsPageUrl) ?>?q=" + jQuery('#<?php echo $instanceId ?>').val();
            <?php
        } else {
            ?>
                            document.location.href = "/scoilnetSearchResults?q=" + jQuery('#<?php echo $instanceId ?>').val();
            <?php
        }
        ?>
                    }
                });
            });
        </script>
        <?php
    }

    function jsWithUrl($instanceId, $urlToCall, $querystring = "") {
        ?>
        <script type="text/javascript">
            jQuery(document).ready(function($) {

                jQuery('#<?php echo $instanceId ?>').on("keypress", function(event) {
                    if (event.keyCode == 13) {
                        jQuery('#ScoilSearch_submit-<?php echo $instanceId ?>').click();
                    }
                });

                jQuery("#ScoilSearch_submit-<?php echo $instanceId ?>").on("click", function() {
                    if (jQuery('#<?php echo $instanceId ?>').val())
                    {
        <?php
        //$scoilnetResources_options= get_option('scoilnetResources_options');
        $searchResultsPageUrl = $urlToCall;
        if (!empty($searchResultsPageUrl)) {
            ?>
                            document.location.href = "<?php echo $searchResultsPageUrl ?>?q=" + jQuery('#<?php echo $instanceId ?>').val() + "<?php echo $querystring ?>";
            <?php
        } else {
            ?>
                            document.location.href = "/scoilnetSearchResults?q=" + jQuery('#<?php echo $instanceId ?>').val() + "<?php echo $querystring ?>";
            <?php
        }
        ?>
                    }
                });
            });
        </script>
        <?php
    }

    /**
     * Front-end display of widget.
     *
     * @see WP_Widget::widget()
     *
     * @param array $args     Widget arguments.
     * @param array $instance Saved values from database.
     */
    public function widget($args, $instance) {

        echo $args['before_widget'];
        if (!empty($instance['title'])) {
            echo $args['before_title'] . apply_filters('widget_title', $instance['title']) . $args['after_title'];
        }
        //echo print_r($instance);
        //echo print_r($args);
        ?>

        <div class="sr_wrapper">
            <div class="sr_mainsearch">
                <div class="sr_row">
                    <div class="sr-10 sr_columns">
                        <input class="sr_inputtext" name="q-<?php echo $args['widget_id'] ?>" id="q-<?php echo $args['widget_id'] ?>" type="search" placeholder="Search Scoilnet.ie">
                    </div>
                    <div class="sr-2 sr_columns">                        
                        <input type="button" class="button sr_submit" name="ScoilSearch_submit-q-<?php echo $args['widget_id'] ?>" id="ScoilSearch_submit-q-<?php echo $args['widget_id'] ?>" value="Search">
                    </div>                    
                </div>

            </div>
        </div>
        <?php
        echo $args['after_widget'];

        if ($instance[searchresultspageurl]) {
            if ($instance[querystring]) {
                $this->jsWithUrl('q-' . $args['widget_id'], $instance[searchresultspageurl], $instance['querystring']);
            } else {
                $this->jsWithUrl('q-' . $args['widget_id'], $instance[searchresultspageurl], '');
            }
        } else {
            $this->js('q-' . $args['widget_id']);
        }
    }

    /**
     * Back-end widget form.
     *
     * @see WP_Widget::form()
     *
     * @param array $instance Previously saved values from database.
     */
    public function form($instance) {

        // PART 1: Extract the data from the instance variable
        $instance = wp_parse_args((array) $instance, array('title' => ''));

        if (isset($instance['title'])) {
            $title = $instance['title'];
        } else {
            $title = __('New title', 'scoilnetResources');
        }

        if (isset($instance['_searchResultsPageUrl'])) {
            $school_level = $instance['_searchResultsPageUrl'];
        }
        ?>        

        <p>
            <label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:'); ?></label>
            <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo esc_attr($title); ?>">
        </p>

        <?php
    }

    /**
     * Sanitize widget form values as they are saved.
     *
     * @see WP_Widget::update()
     *
     * @param array $new_instance Values just sent to be saved.
     * @param array $old_instance Previously saved values from database.
     *
     * @return array Updated safe values to be saved.
     */
    public function update($new_instance, $old_instance) {
        $instance = array();
        $instance = $old_instance;

        $instance['title'] = (!empty($new_instance['title']) ) ? strip_tags($new_instance['title']) : '';

        return $instance;
    }

}

function register_foo_widget() {
    register_widget('scoilnetResources_SearchBoxWidget');
}

add_action('widgets_init', 'register_foo_widget');
