<?php

require_once( scoilnetResources_DIR . 'scoilnetResources.php' );

class scoilnetResources_button {

    public function __construct() {
        add_action('admin_head', array($this, 'scoilnetResources_tc_button'));
        add_action('admin_enqueue_scripts', array($this, 'scoilnetResources_tc_css'));
    }

    function scoilnetResources_tc_button() {
        global $typenow;
        // check user permissions
        if (!current_user_can('edit_posts') && !current_user_can('edit_pages')) {
            return;
        }
        // verify the post type
        if (!in_array($typenow, array('post', 'page')))
            return;
        // check if WYSIWYG is enabled
        if (get_user_option('rich_editing') == 'true') {
            add_filter("mce_external_plugins", array($this, 'scoilnetResources_add_tinymce_plugin'));
            add_filter('mce_buttons', array($this, 'scoilnetResources_register_my_tc_button'));
        }
    }

    function scoilnetResources_add_tinymce_plugin($plugin_array) {
        $plugin_array['scoilnetResources_tc_button'] = plugins_url('/js/scoilnet-button.js', __FILE__);
        return $plugin_array;
    }

    function scoilnetResources_register_my_tc_button($buttons) {
        array_push($buttons, "scoilnetResources_tc_button");
        return $buttons;
    }

    function scoilnetResources_tc_css() {
        wp_enqueue_style('scoilnet-button', scoilnetResources_URL . 'css/scoilnet-button.css', false);
        wp_enqueue_style('select2', scoilnetResources_URL . 'js/select2/select2.css', false);
        wp_enqueue_script('select2', scoilnetResources_URL . 'js/select2/select2.min.js', array('jquery'), false, false);
    }

}

$scoilnetResources_button = new scoilnetResources_button();
