<?php

require_once( scoilnetResources_DIR . 'scoilnetResources.php' );
require_once( scoilnetResources_DIR . '/views/resultsTemplate.php' );

class scoilnetResources_shortcodes {

    public function __construct() {
        add_shortcode('widget', array($this, 'widget'));
        add_shortcode('getScoilnetResults', array($this, 'getScoilnetResults_func'));
    }

    function getScoilnetResults_func($atts) {
        //$scoilnetResources_options= get_option('scoilnetResources_options');
        // as per discussion the query priorities are...
        // 1) querystring, [low]
        // 2) then default overrides, [medium]
        // 3) then per page overrides [high]

        $defaultParams = array();
        $wiredParams = array();
        $userSessionParams = array();
        // 1
        $defaultParams = $this->getParamsFilterForQ($defaultParams);

        // 2
        $scoilnetResources_options = get_option('scoilnetResources_options');

        foreach ($scoilnetResources_options as $key => $value) {
            if (substr($key, 0, 1) === '_') {
                if ($value) {
                    //$defaultParams[substr($key, 1)] = $value;
                    //$wiredParams[substr($key, 1)] = $value;
                    $userSessionParams[substr($key, 1)] = $value;
                }
            } else {
                if ($value) {
                    $defaultParams[$key] = $value;
                    $wiredParams[$key] = $value;
                }
            }
        }

        // 3
        if ($atts) {
            foreach ($atts as $key => $value) {
                if ($value) {
                    $defaultParams[$key] = $value;
                    $wiredParams[$key] = $value;
                }
            }
        }

        $scoilnetResources = new scoilnetResources();
        $resultsTemplate = new resultsTemplate();

        $resultsTemplate->displayResults($scoilnetResources->searchWithParameters($defaultParams, $userSessionParams), $wiredParams);

        //return $scoilnetResources->searchWithParameters($defaultParams);
    }

    /**
     * Gets and filters all paramaters
     * @return array
     */
    public static function getParamsFilterForQ($params) {
        //$params = array();
        //echo INPUT_GET;
        //echo filter_input_array(INPUT_GET);
        $my_var = filter_input_array(INPUT_GET);
        if (!empty($my_var)) {
            foreach ($my_var as $paramName => $paramValue) {
                //if ($paramName === 'q') {
                $params[$paramName] = $paramValue;
                //}  
            }
        }
        return $params;
    }

    function widget($atts) {

        global $wp_widget_factory;

        extract(shortcode_atts(array(
            'widget_name' => FALSE,
            'instance' => ''), $atts));

        $instance = str_ireplace("&amp;", '&', $instance);

        if ($atts['searchresultspageurl']) {
            $instance['searchresultspageurl'] = $atts['searchresultspageurl'];
        }

        if ($atts['attributestopass']) {
            $instance['querystring'] = "&" . str_replace(",", "&", $atts['attributestopass']);
        }

        $widget_name = wp_specialchars($widget_name);

        if (!is_a($wp_widget_factory->widgets[$widget_name], 'WP_Widget')):
            $wp_class = 'WP_Widget_' . ucwords(strtolower($class));

            if (!is_a($wp_widget_factory->widgets[$wp_class], 'WP_Widget')):
                return '<p>' . sprintf(__("%s: Widget class not found. Make sure this widget exists and the class name is correct"), '<strong>' . $class . '</strong>') . '</p>';
            else:
                $class = $wp_class;
            endif;
        endif;

        ob_start();
        the_widget($widget_name, $instance, array('widget_id' => 'arbitrary-instance-' . $id,
            'before_widget' => '',
            'after_widget' => '',
            'before_title' => '',
            'after_title' => ''
        ));
        $output = ob_get_contents();
        ob_end_clean();
        return $output;
    }

}

$scoilnetResources_shortcodes = new scoilnetResources_shortcodes();
