<?php

require_once('sdk/ScoilnetClient.php');

/**
 * Extends Scoilnet Client to use wordpress caching to store the token key from OAuth2
 *
 * @author paul schweppe
 */
class ScoilnetWPClient extends ScoilnetSDK\ScoilnetClient {

    protected function getSessionFromFileCache() {

        if (false !== ( $session = get_transient('scoilnetToken') )) {
            if ($session['expires'] > (time() - 30)) {
                return $session;
            } else {
                return NULL;
            }
        }

        return false;
    }

    /**
     * Override method to use wordpress transient storage
     */
    protected function setSessionInFileCache($session) {
        //die(print_r($session,true));
        set_transient('scoilnetToken', $session, 3600);
    }

}
